package javaspacesdatenstrukturen;

import net.jini.space.*;
import net.jini.core.lease.*;

/**
 * Title:        Verteilte Datenstrukturen
 * Description:  Building Blocks fr verteilte Anwendungen mit JavaSpaces
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class ChannelCreator {
    private JavaSpace space;

    public static void main(String[] args) {
        System.out.println("[ChannelCreator.main()]Start");

        ChannelCreator creator = new ChannelCreator();
        String channel="MP3Channel";
        if (args.length>0) channel=args[0];
        creator.createChannel(channel);
        System.out.println("[ChannelCreator.main()]Channel="+channel);
        System.out.println("[ChannelCreator.main()]Ende");
    }

    private void createChannel(String channelName) {
        System.out.println("[ChannelCreator.createChannel()]");
        space = SpaceAccessor.getSpace();
        Index head =
                new Index("head", channelName, new Integer(1));
        Index tail =
                new Index("tail", channelName, new Integer(0));

        System.out.println("[ChannelCreator.createChannel()]Kreiere einen neuen Channel: " + channelName + ".");
        try {
            space.write(head, null, Lease.FOREVER);
            space.write(tail, null, Lease.FOREVER);
        } catch (Exception e) {
            System.out.println("[ChannelCreator.createChannel()]Fehler beim Kreieren des Channels.");
            e.printStackTrace();
            return;
        }
        System.out.println("[ChannelCreator.createChannel()]Channel " + channelName + " wurde kreiert.");
    }
}


