package javaspacesdatenstrukturen;

import net.jini.core.entry.Entry;

/**
 * Title:        Verteilte Datenstrukturen
 * Description:  Building Blocks fr verteilte Anwendungen mit JavaSpaces
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Index implements Entry {
    public String type;        // head oder tail
    public String channel;
    public Integer position;

    public Index() {
    }

    public Index(String type, String channel) {
        this.type = type;
        this.channel = channel;
    }

    public Index(String type, String channel, Integer position) {
        this.type = type;
        this.channel = channel;
        this.position = position;
    }

    public Integer getPosition() {
        return position;
    }

    public void increment() {
        position = new Integer(position.intValue() + 1);
    }
}

