package javaspacesdatenstrukturen;

import java.io.*;

/**
 * Title:        Verteilte Datenstrukturen
 * Description:  Building Blocks fr verteilte Anwendungen mit JavaSpaces
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Utils {

    public Utils() {
    }

    public static byte[] getRawData(String filePath) {
        System.out.println("[Utils.getRawData()]");

        byte[] data = null;

        File file = new File(filePath);
        if (!file.exists()) {
            return null;
        }

        int contentLength = (int)file.length();
        if (contentLength == 0) { // Datei wurde nicht gefunden
            return null;
        }

        try {
            data = new byte[(int)contentLength];
            FileInputStream fis = new FileInputStream(file);
            fis.read(data);
            fis.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return data;
    }


    public static void putRawData(byte[] data, String filePath) {
        System.out.println("[Utils.putRawData()]");
        try {
            FileOutputStream fos = new FileOutputStream(filePath);
            fos.write(data);
            fos.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
