package javaspacesfehlertoleranz;

import com.sun.jini.mahout.binder.RefHolder;
import com.sun.jini.outrigger.*;
import java.io.PrintStream;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import net.jini.space.JavaSpace;

/**
 * Title:        Fehlertoleranz in JavaSpaces Applikationen
 * Description:  Verteilter Rechenr mit Transaktionen zur Erhhung der Fehlertoleranz
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

 public class SpaceAccessor
{

    public SpaceAccessor()
    {
    }

    public static JavaSpace getSpace()
    {
        return getSpace("JavaSpaces");
    }

    public static JavaSpace getSpace(String s)
    {
        try
        {
            if(System.getSecurityManager() == null)
                System.setSecurityManager(new RMISecurityManager());
            if(System.getProperty("com.sun.jini.use.registry") == null)
            {
                DiscoveryLocator discoverylocator = new DiscoveryLocator();
                LookupFinder lookupfinder = new LookupFinder();
                return (JavaSpace)lookupfinder.find(discoverylocator, s);
            } else
            {
                RefHolder refholder = (RefHolder)Naming.lookup(s);
                return (JavaSpace)refholder.proxy();
            }
        }
        catch(Exception exception)
        {
            System.err.println(exception.getMessage());
        }
        return null;
    }
}
