package javaspacesmandelbrot;

import java.rmi.*;

import net.jini.core.transaction.server.TransactionManager;

import com.sun.jini.mahout.Locator;
import com.sun.jini.outrigger.Finder;

/**
 * Title:        Mandelbrot Set als JavaSpaces Anwendung
 * Description:  Einfaches Beispiel fr den Master-Slave Aufbau einer JavaSpaces Anwendung
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

 public class TransactionManagerAccessor {
/**
 * Hilfsklasse (~java.util fr JavaSpaces)
 */
    public static TransactionManager getManager(String name) {
            Locator locator = null;
            Finder finder = null;

            if (System.getSecurityManager() == null) {
            System.setSecurityManager(
                new RMISecurityManager());
        }

            if (System.getProperty("com.sun.jini.use.registry") != null) {
                locator = new com.sun.jini.mahout.RegistryLocator();
                finder = new com.sun.jini.outrigger.RegistryFinder();
            } else {
                locator = new com.sun.jini.outrigger.DiscoveryLocator();
                finder = new com.sun.jini.outrigger.LookupFinder();
            }

        return (TransactionManager)finder.find(locator, name);
    }

    public static TransactionManager getManager() {
        return getManager(com.sun.jini.mahalo.TxnManagerImpl.DEFAULT_NAME);
    }
}
