package javaspacesskalierbarkeit;

import java.rmi.*;
import net.jini.core.lookup.*;
import net.jini.space.JavaSpace;
import com.sun.jini.mahout.binder.RefHolder;
import com.sun.jini.mahout.Locator;
import com.sun.jini.outrigger.Finder;

/**
 * Title:        Skalierbarkeit von JavaSpaces Lsungen
 * Description:  Verteilter Rechenr, der ber mehere JavaSpaces die Arbeit verteiltund wieder einsammelt
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class SpaceAccessor {
    public static JavaSpace getSpace(String name) {
        try {
            if (System.getSecurityManager() == null) {
                System.setSecurityManager(new RMISecurityManager());
            }

            if (System.getProperty("com.sun.jini.use.registry")
                == null)
            {
                Locator locator =
                    new com.sun.jini.outrigger.DiscoveryLocator();
                Finder finder =
                    new com.sun.jini.outrigger.LookupFinder();
                return (JavaSpace)finder.find(locator, name);
            } else {
                RefHolder rh = (RefHolder)Naming.lookup(name);
                return (JavaSpace)rh.proxy();
            }
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
        return null;
    }

    public static JavaSpace getSpace() {
        return getSpace("JavaSpaces");
    }


    public static ServiceMatches getSpaces() {
        try {
            if (System.getSecurityManager() == null) {
                System.setSecurityManager(new RMISecurityManager());
            }

            Locator locator = new com.sun.jini.outrigger.DiscoveryLocator();
            ServiceRegistrar lookupService = (ServiceRegistrar)locator.locate();

            Class[] types = { JavaSpace.class };
            ServiceTemplate template = new ServiceTemplate(null, types, null);
            ServiceMatches matches = lookupService.lookup(template, 50);
            return matches;
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
        return null;
    }


}
