package javaspacessynchronisation;

import java.rmi.*;
import java.rmi.server.*;

/**
 * Title:        Synchronisation von JavaSpaces Anwendungen
 * Description:  Einfaches Spiel, welches die Synchronisation mehrerer Tasks zeigt, welche auf Objekte in einem Java Space zugreifen.
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class GameImpl extends UnicastRemoteObject
    implements Game {

    private String name;

    public GameImpl(String name) throws RemoteException {
        super();
        this.name = name;

        // security manager
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }
    }

    // Ausgabe und schlafen
    public void play(String playerName) {
        for (int i = 0; i < 5; i++) {
            System.out.println("[GameImpl]playerName " +playerName+ " ist am spielen...");

            try {
                Thread.sleep(2000);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}