package javaspacesverteilterrechner;

import net.jini.core.entry.Entry;
import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;

/**
 * Title:        Distributed Computing
 * Description:  einfacher Rechner, welcher JavaSpaces als Kommunikationsplattform, Objektrepository fr die Kommunikation zwischen Clients und dem Master / Server verwendet.
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Worker {
    JavaSpace space;

    public static void main(String[] args) {
        System.out.println("[Worker]main() Start");
        Worker worker = new Worker();
        worker.startWork();
    }

    public Worker() {
        space = SpaceAccessor.getSpace();
    }

    public void startWork() {
        System.out.println("[Master]startWork()");
        TaskEntry template = new TaskEntry();

        for (;;) {
            try {
                TaskEntry task = (TaskEntry)
                    space.take(template, null, Long.MAX_VALUE);
                Entry result = task.execute();
                if (result != null) {
                    space.write(result, null, 1000*60*10);
                }
            } catch (Exception e) {
                System.out.println("Task wurde gecancelled");
            }
        }
    }
}
